// Explicit template instantiation

template void EDIPC::Pair<false, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<false, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Pair<true, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);

template void EDIPC::PairZbl<false, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<false, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::PairZbl<true, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);

template void EDIPC::Triple<false, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<false, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, false, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, false, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, false, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, false, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, false, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, true, false, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, true, false, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, true, true, false>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
template void EDIPC::Triple<true, true, true, true, true>(
    std::size_t const, int const *const, double *const, VectorOfSizeDIM *const,
    double *const, VectorOfSizeSix, VectorOfSizeSix *const);
